Your submission was sent successfully! Close

  1. Blog
  2. Article

Adam Stokes
on 27 July 2017

Conjure-up dev summary highlights: screen ordering and improved deploy


Screen Ordering

Previously, you would go through the install journey by picking your spell, selecting a cloud, modifying charm options, and then waiting for bootstrap/applications to be completely deployed prior to performing the post processing steps. In this latest update we’ve moved all steps to be completed prior to any of those longer blocking tasks.

This allows you to see the complete picture and giving you the ability to go back and make updates to your configuration items prior to running the longer tasks of the deployment.

Deployment resilience

We use a mechanism for determining when a deployment has “finished”, meaning, all hooks have been fired and each application is in a ready state to handle the next set of instructions from the installer. In some cases an application may get into a state of error but quickly resolve itself.

This was causing us some issues as we were taking a very strict approach that if there is an error in the application then the deployment should fail. Even though this is the proper thing to do we’ve made a decision that if the application is able to fix itself then we shouldn’t pass on that failed experience to the user since technically the deployment is able to finish and function as intended.

To combat this we’ve made our deployment checker a little more lenient and performing retries (up to 5 times) to validate if an application does fix itself. However, since an error was seen in the application it should not go unnoticed and needs to be fixed in the charm itself. In our integration tests we have an environment variable CONJURE_UP_MODE that can be set to test and gives us the ability to fail on charm failures and get those bugs reported upstream and resolved.

Spell authors can make use of this feature in their own spells by updating the 00_deploy-done script with the following bits:

#!/bin/bash
set -eux
. "$CONJURE_UP_SPELLSDIR/sdk/common.sh"
retry_arg="-r5"
if [[ "${CONJURE_UP_MODE-}" == "test" ]]; then
 retry_arg=""
fi
if ! juju wait $retry_arg -vwm "$JUJU_CONTROLLER:$JUJU_MODEL"; then
 setResult "Applications did not start successfully"
 exit 1
fi
setResult "Applications Ready"
exit 0

Getting these changes

Installing the snap from the edge channel will give you the latest work outlined in these developer summaries:

sudo snap install conjure-up --classic --edge

 



    

Related posts


Bill Wear
30 November 2023

MOTL: Minis Forum N33 NUC

Cloud and server Article

Part 1: The hardware setup As a first attempt at trying MAAS outside the lines (MOTL), let’s pick a random, inexpensive Next Unit of Computing (NUC). Indeed, let’s start with a Minis Forum N33, which is older and “out of print.” The relevant forum is offline, and manuals are hard to Google up. Nice challenge. ...


Serdar Vural
30 November 2023

Fast and reliable telco edge clouds with Intel FlexRAN and Real-time Ubuntu for 5G URLLC scenarios

Cloud and server Article

Intel and Canonical have been collaborating to deliver advanced infrastructure that can run the networks of the future. More and more, we see edge cloud systems deployed closer to end users and systems to meet the ever-increasing demand for faster edge networks that can rapidly deliver business services and boost productivity. This requir ...


lizzieepton
29 November 2023

Meet Canonical at CES 2024

Ubuntu Article

It’s that exciting time of year, CES is almost here. With 2880+ exhibitors, the Consumer Electronics Show (CES) has cemented its position as the premier event for unveiling the latest technological advancements. With each passing year, CES becomes an even more integral platform for showcasing groundbreaking innovations. Join us at booth 9 ...